static bool color_picker(HWND parent, cfg_int &out, COLORREF custom = 0)
{
	bool rv = false;
	COLORREF COLOR = out;
	COLORREF COLORS[16] = {custom,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	if (uChooseColor(&COLOR, parent, &COLORS[0]))
	{
		out = COLOR;
		rv = true;
	}
	return rv;
}

void set_handle (metadb_handle_ptr & target, metadb_handle_ptr src)
{
	if (src == target) return;
	
	if (target.is_valid()) target.release();

	if (src.is_valid()) target.copy(src);
}

#ifdef ENABLE_MATROSKA

string8 findFirstImageMatch(string8 p) {
	p.replace_char('/','\\');
	string8 base_path=p;
	base_path.truncate(p.find_first('\\',p.find_first("*")));
	base_path.truncate(1+base_path.find_last('\\'));
	WIN32_FIND_DATA data;
	HANDLE hFind;
	if((hFind=FindFirstFile(stringcvt::string_wide_from_utf8(p),&data))==INVALID_HANDLE_VALUE){
		FindClose(hFind);
		return NULL;
	}
	do {
		string8 path=base_path;
		path.add_string(stringcvt::string_utf8_from_wide(data.cFileName));
		Bitmap bmp(stringcvt::string_wide_from_utf8(path.get_ptr()));
		if (bmp.GetHeight()) {
			FindClose(hFind);
			return path;
		}
	} while (FindNextFile(hFind, &data));
	FindClose(hFind);
	return NULL;
}
#else
string8 findFirstImageMatch(string8 p,string8 po)
{
	p.replace_char('/','\\');
	if(!wildcard_helper::has_wildcards(p) && wildcard_helper::test(p,po)){
		Bitmap bmp(stringcvt::string_wide_from_utf8(p.get_ptr()));
		if(bmp.GetHeight())
			return p;
		else
			return NULL;
	}
	p.truncate(p.find_first('\\',p.find_first("*")));
	string8 base_path=p;
	base_path.truncate(1+base_path.find_last('\\'));
	WIN32_FIND_DATA data;
	HANDLE hFind;
	if((hFind=FindFirstFile(stringcvt::string_wide_from_utf8(p),&data))==INVALID_HANDLE_VALUE){
		FindClose(hFind);
		return NULL;
	}
	do
	{
		if(stricmp_utf8(stringcvt::string_utf8_from_wide(data.cFileName),".")!=0 && stricmp_utf8(stringcvt::string_utf8_from_wide(data.cFileName),"..")!=0)
		{
			string8 path=base_path;
			path.add_string(stringcvt::string_utf8_from_wide(data.cFileName));
			string8 pattern=po;
			pattern.remove_chars(0,p.length());
			path.add_string(pattern);
			path=findFirstImageMatch(path,po);
			if(!path.is_empty()){
				FindClose(hFind);
				return path;
			}
		}
	}while(FindNextFile(hFind,&data));
	FindClose(hFind);
	return NULL;
}

string8 findFirstImageMatch(string8 p)
{
	return findFirstImageMatch(p,p);
}
#endif