enum
{
	WM_FOO_CALLBACK = WM_USER,
	PLAYLIST_FOCUS_CHANGE=0,
	PLAYBACK_NEW_TRACK,
	PLAYBACK_STOP,
	VARIABLE_CHANGE,
	APP_INIT,
	APP_QUIT,
};

/*
class albumart_var_notify : public config_object_notify
{
private:
	list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual t_size get_watched_object_count()
	{
		return 14;
	}
	virtual GUID get_watched_object(t_size p_index)
	{
		switch (p_index)
		{
			case 0: return cfg_src_list_guid;
			case 1: return cfg_centeralbum_guid;
			case 2: return cfg_expandalbum_guid;
			case 3: return cfg_shrinkalbum_guid;
			case 4: return cfg_selected_guid;
			case 5: return cfg_usebg_guid;
			case 6: return cfg_bgcol_guid;
			case 7: return cfg_aspectratio_guid;
			case 8: return cfg_pixelborder_guid;
			case 9: return cfg_interpolationmode_guid;
			case 10: return cfg_usecontrol_guid;
			case 11: return cfg_minheight_guid;
			case 12: return cfg_resetsource_guid;
			case 13: return cfg_padding_guid;
		}
		return GUID_NULL;
	}
	virtual void on_watched_object_changed(const service_ptr_t<config_object> & p_object)
	{
		int i, n = hwnds.get_count();
		config_object * object = p_object.get_ptr();
		for (i = 0; i<n; i++)
		{
			object->service_add_ref();
			SendMessage(hwnds[i],WM_FOO_CALLBACK,VARIABLE_CHANGE,(long)object);
		}
	}
};

static service_factory_single_transparent_t<albumart_var_notify> foo_uie_albumart_var_notify;
*/

class albumart_playback_notify : public play_callback_static
{
private:
	list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual unsigned get_flags() {
		return flag_on_playback_new_track | flag_on_playback_stop;
	}
	virtual void on_playback_new_track(metadb_handle_ptr p_track) {
		int i, n = hwnds.get_count();
		metadb_handle * track = p_track.get_ptr();
		for (i = 0; i<n; i++)
		{
			track->service_add_ref();
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYBACK_NEW_TRACK,(long)track);
		}
	}
	virtual void on_playback_stop(play_control::t_stop_reason p_reason) {
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYBACK_STOP,(long)p_reason);
	}
	virtual void on_playback_starting(play_control::t_track_command p_command,bool p_paused) {}
	virtual void on_playback_seek(double p_time) {}
	virtual void on_playback_pause(bool p_state) {}
	virtual void on_playback_edited(metadb_handle_ptr p_track) {}
	virtual void on_playback_dynamic_info(const file_info & p_info) {}
	virtual void on_playback_dynamic_info_track(const file_info & p_info) {}
	virtual void on_playback_time(double p_time) {}
	virtual void on_volume_change(float p_new_val) {}
};

static play_callback_static_factory_t<albumart_playback_notify> foo_uie_albumart_playback_notify;

class albumart_playlist_notify : public playlist_callback_single_static
{
private:
	list_t<HWND> hwnds;
public:
	void add_window(HWND wnd) { hwnds.add_item(wnd); }
	void remove_window(HWND wnd) { hwnds.remove_item(wnd); }
	virtual unsigned get_flags()
	{
		return flag_on_item_focus_change;
	}
	virtual void on_item_focus_change(t_size p_from,t_size p_to)
	{
		int i, n = hwnds.get_count();
		for (i = 0; i<n; i++)
			SendMessage(hwnds[i],WM_FOO_CALLBACK,PLAYLIST_FOCUS_CHANGE,p_to);
	}
	virtual void on_items_added(t_size start, const pfc::list_base_const_t<metadb_handle_ptr> & p_data,const bit_array & p_selection) {}
	virtual void on_items_reordered(const t_size * order,t_size count) {}
	virtual void on_items_removing(const bit_array & p_mask,t_size p_old_count,t_size p_new_count) {}
	virtual void on_items_removed(const bit_array & p_mask,t_size p_old_count,t_size p_new_count) {}
	virtual void on_items_selection_change(const bit_array & p_affected,const bit_array & p_state) {}
	virtual void on_items_modified(const bit_array & p_mask) {}
	virtual void on_items_modified_fromplayback(const bit_array & p_mask,play_control::t_display_level p_level) {}
	virtual void on_items_replaced(const bit_array & p_mask,const pfc::list_base_const_t<playlist_callback::t_on_items_replaced_entry> & p_data) {}
	virtual void on_item_ensure_visible(t_size p_idx) {}

	virtual void on_playlist_switch() {}
	virtual void on_playlist_renamed(const char * p_new_name,t_size p_new_name_len) {}
	virtual void on_playlist_locked(bool p_locked) {}

	virtual void on_default_format_changed() {}
	virtual void on_playback_order_changed(t_size p_new_index) {}
};

static service_factory_single_transparent_t<albumart_playlist_notify> foo_uie_albumart_playlist_notify;